package org.jee.soa.service.account;

import org.jee.soa.dao.account.AccountDAO;
import org.jee.soa.domain.account.Account;
import org.jee.soa.domain.account.AccountTransaction;
import org.jee.soa.domain.customer.Customer;

import javax.ejb.EJB;
import javax.ejb.Stateless;
import java.util.List;

/**
 * @author David A. Freels Sr.
 */
@Stateless(mappedName = "service/account/AccountService")
public class AccountServiceImpl implements AccountService
{
	@EJB(mappedName = "dao/account/AccountDAO", beanInterface = AccountDAO.class)
	AccountDAO accountDAO;
	
	public List<Account> findCustomerAccounts(Customer customer)
	{
		return accountDAO.findCustomerAccounts(customer);
	}

	public List<AccountTransaction> getAccountTransactions(Account account)
	{
		return accountDAO.getAccountTransactions(account);
	}
}
