package org.jee.soa.service.customer;

import org.jee.soa.dao.customer.CustomerDAO;
import org.jee.soa.domain.customer.Customer;

import javax.ejb.EJB;
import javax.ejb.Stateless;

/**
 * @author David A. Freels Sr.
 */
@Stateless(mappedName = "service/customer/CustomerService")
public class CustomerServiceImpl implements CustomerService
{
	@EJB(mappedName = "dao/customer/CustomerDAO", beanInterface = CustomerDAO.class)
	CustomerDAO customerDAO;

	public Customer findCustomerByName(String firstName, String lastName)
	{
		return customerDAO.findCustomerByName(firstName, lastName);
	}

	public Customer getCustomerById(int customerId)
	{
		return customerDAO.getCustomerById(customerId);
	}
}
