CREATE SCHEMA `jeesoa` DEFAULT CHARACTER SET utf8;

CREATE  TABLE `jeesoa`.`customer` (
  `customer_id` INT NOT NULL AUTO_INCREMENT ,
  `first_name` VARCHAR(45) NOT NULL ,
  `last_name` VARCHAR(45) NOT NULL ,
  `creation_date` DATETIME NOT NULL ,
  PRIMARY KEY (`customer_id`) ,
  INDEX `cust_lname_idx` (`last_name` ASC) ,
  INDEX `cust_fname_idx` (`first_name` ASC) ,
  INDEX `cust_date_idx` (`creation_date` ASC) );

CREATE  TABLE `jeesoa`.`account` (
  `account_id` INT NOT NULL AUTO_INCREMENT ,
  `account_number` VARCHAR(45) NOT NULL ,
  `balance` DECIMAL NOT NULL ,
  `creation_date` DATETIME NOT NULL ,
  UNIQUE INDEX `account_number_UNIQUE` (`account_number` ASC) ,
  PRIMARY KEY (`account_id`) ,
  INDEX `acct_acct_num_idx` (`account_number` ASC) );

CREATE  TABLE `jeesoa`.`customer_account` (
  `customer_id` INT NOT NULL ,
  `account_id` VARCHAR(45) NOT NULL ,
  PRIMARY KEY (`customer_id`, `account_id`) ,
  INDEX `cust_accnt_cust_id_fk` (`customer_id` ASC) ,
  INDEX `cust_accnt_accnt_id_fk` (`account_id` ASC) ,
  CONSTRAINT `cust_accnt_cust_id_fk`
    FOREIGN KEY (`customer_id` )
    REFERENCES `jeesoa`.`customer` (`customer_id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `cust_accnt_accnt_id_fk`
    FOREIGN KEY (`account_id` )
    REFERENCES `jeesoa`.`account` (`account_number` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION);

CREATE  TABLE `jeesoa`.`transaction_type` (
  `transaction_type_id` INT NOT NULL AUTO_INCREMENT ,
  `description` VARCHAR(250) NOT NULL ,
  `operation` VARCHAR(1) NOT NULL ,
  PRIMARY KEY (`transaction_type_id`) );

CREATE  TABLE `jeesoa`.`account_transaction` (
  `account_transaction_id` INT NOT NULL AUTO_INCREMENT ,
  `account_id` INT NOT NULL ,
  `transaction_amount` VARCHAR(45) NOT NULL ,
  `transaction_type_id` INT NOT NULL ,
  `creation_date` DATETIME NOT NULL ,
  PRIMARY KEY (`account_transaction_id`) ,
  INDEX `acct_tran_acct_id_fk` (`account_id` ASC) ,
  INDEX `acct_tran_tran_type_fk` (`transaction_type_id` ASC) ,
  CONSTRAINT `acct_tran_acct_id_fk`
    FOREIGN KEY (`account_id` )
    REFERENCES `jeesoa`.`account` (`account_id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `acct_tran_tran_type_fk`
    FOREIGN KEY (`transaction_type_id` )
    REFERENCES `jeesoa`.`transaction_type` (`transaction_type_id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION);

INSERT INTO `jeesoa`.`transaction_type` (`description`, `operation`) VALUES ('This operation applies a increments the balance', '+');
INSERT INTO `jeesoa`.`transaction_type` (`description`, `operation`) VALUES ('This operation applies a decrements the balance', '-');
